unit Usetbus;

{
  IIC-Bus Universal

  Freeware, Copyright 1996, Matthias Weingart;
  comments, bug reports to matthias@penthouse.boerde.de
}

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, SysUtils, IniFiles, unii2c, ustrdlg;

type
  TBusSettingsDlg = class(TForm)
    Panel2: TPanel;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    Label1: TLabel;
    Panel1: TPanel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Panel3: TPanel;
    Label6: TLabel;
    ComboBox4: TComboBox;
    ComboBox5: TComboBox;
    ComboBox6: TComboBox;
    Panel4: TPanel;
    Label7: TLabel;
    ComboBox7: TComboBox;
    ComboBox8: TComboBox;
    ComboBox9: TComboBox;
    Panel5: TPanel;
    Label8: TLabel;
    ComboBox10: TComboBox;
    ComboBox11: TComboBox;
    ComboBox12: TComboBox;
    Label9: TLabel;
    ComboBox13: TComboBox;
    ComboBox14: TComboBox;
    ComboBox15: TComboBox;
    Panel6: TPanel;
    Button1: TButton;
    Button2: TButton;
    ProfileCb: TComboBox;
    Label10: TLabel;
    SaveAsBtn: TButton;
    SaveBtn: TButton;
    DeleteBtn: TButton;
    Label11: TLabel;
    Label12: TLabel;
    BAdr0Edit: TEdit;
    Label14: TLabel;
    BAdr2Edit: TEdit;
    procedure SaveAsBtnClick(Sender: TObject);
    procedure SaveBtnClick(Sender: TObject);
    procedure ProfileCbChange(Sender: TObject);
    procedure DeleteBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Ini: TIniFile;
    procedure SetProfile( I2C: TPI2C );
    procedure GetProfile( I2C: TPI2C );
    procedure StoreIni( section: string );
    procedure ReadIni( section: string );
    procedure InitProfileCb;
    procedure Save;
    procedure SaveAs;
    procedure Delete;
  end;

var
  BusSettingsDlg: TBusSettingsDlg;

implementation

{$R *.DFM}
const
   MirTronic: array[1..15] of integer= (0, 5, 1, 1, 8, 1, 0, 8, 0, 1, 0, 0, 0, 1, 0 );
   Philips:   array[1..15] of integer= (1, 8, 1, 1, 8, 0, 2, 4, 0, 1, 4, 0, 0, 0, 0 );

function Idx2Adr( idx: Integer ): Integer;
begin
    Result:=Idx;
end;

function Adr2Idx( Adr: Integer ): Integer;
begin
    Result:=Adr;
end;

function Idx2Mask( idx: integer ): byte;
begin
   Result:=0;
   case idx of
    1: Result:=1;
    2: Result:=2;
    3: Result:=4;
    4: Result:=8;
    5: Result:=$10;
    6: Result:=$20;
    7: Result:=$40;
    8: Result:=$80;
   end;
end;

function Mask2Idx( Mask: byte ): integer;
begin
   Result:=0;
   case Mask of
     $01: Result:=1;
     $02: Result:=2;
     $04: Result:=3;
     $08: Result:=4;
     $10: Result:=5;
     $20: Result:=6;
     $40: Result:=7;
     $80: Result:=8;
   end;
end;

function Idx2Inv( idx: integer): boolean;
begin
    Result := idx<>0;
end;

function Inv2Idx( inv: boolean ): integer;
begin
    if inv then
       Result:=1
    else
       Result:=0;
end;

procedure TBusSettingsDlg.SetProfile( I2C: TPI2C );
begin
     with I2C do
     begin
      try
        InitialPortValue0 := StrToInt( '$0'+BAdr0Edit.Text );
        InitialPortValue2 := StrToInt( '$0'+BAdr2Edit.Text );
        SdaOutPortAdr := Idx2Adr( ComboBox1.ItemIndex );
        SdaOutMask    := Idx2Mask(ComboBox2.ItemIndex );
        SdaOutInverted:= Idx2Inv( ComboBox3.ItemIndex );
        SdaInPortAdr  := Idx2Adr( ComboBox4.ItemIndex );
        SdaInMask     := Idx2Mask(ComboBox5.ItemIndex );
        SdaInInverted := Idx2Inv( ComboBox6.ItemIndex );
        SclOutPortAdr := Idx2Adr( ComboBox7.ItemIndex );
        SclOutMask    := Idx2Mask(ComboBox8.ItemIndex );
        SclOutInverted:= Idx2Inv( ComboBox9.ItemIndex );
        SclInPortAdr  := Idx2Adr( ComboBox10.ItemIndex );
        SclInMask     := Idx2Mask(ComboBox11.ItemIndex );
        SclInInverted := Idx2Inv( ComboBox12.ItemIndex );
        ChargePumpPortAdr  := Idx2Adr( ComboBox13.ItemIndex );
        ChargePumpMask     := Idx2Mask(ComboBox14.ItemIndex );
        ChargePumpInverted := Idx2Inv( ComboBox15.ItemIndex );
      except
         on EConvertError do Application.Messagebox('Invalid default values.','Error',MB_APPLMODAL);
      end;
     end;
end;

procedure TBusSettingsDlg.GetProfile( I2C: TPI2C );
begin
     with I2C do
     begin
        BAdr0Edit.Text := IntToHex( InitialPortValue0,2 );
        BAdr2Edit.Text := IntToHex( InitialPortValue2,2 );
        ComboBox1.ItemIndex := Adr2Idx(  SdaOutPortAdr );
        ComboBox2.ItemIndex := Mask2Idx( SdaOutMask );
        ComboBox3.ItemIndex := Inv2Idx(  SdaOutInverted );
        ComboBox4.ItemIndex := Adr2Idx(  SdaInPortAdr );
        ComboBox5.ItemIndex := Mask2Idx( SdaInMask );
        ComboBox6.ItemIndex := Inv2Idx(  SdaInInverted );
        ComboBox7.ItemIndex := Adr2Idx(  SclOutPortAdr );
        ComboBox8.ItemIndex := Mask2Idx( SclOutMask );
        ComboBox9.ItemIndex := Inv2Idx(  SclOutInverted );
        ComboBox10.ItemIndex:= Adr2Idx(  SclInPortAdr );
        ComboBox11.ItemIndex:= Mask2Idx( SclInMask );
        ComboBox12.ItemIndex:= Inv2Idx(  SclInInverted );
        ComboBox13.ItemIndex:= Adr2Idx(  ChargePumpPortAdr );
        ComboBox14.ItemIndex:= Mask2Idx( ChargePumpMask );
        ComboBox15.ItemIndex:= Inv2Idx(  ChargePumpInverted );
     end;
end;

procedure TBusSettingsDlg.StoreIni( section: string );
var i: Integer;
begin
    for i:=0 to ComponentCount-1 do
     if (Components[i].Tag>0) and (Components[i] is TComboBox) then
        Ini.WriteInteger( section, IntToStr(Components[i].Tag), TComboBox(Components[i]).ItemIndex );
    Ini.WriteString( section, 'Default0', BAdr0Edit.Text );
    Ini.WriteString( section, 'Default2', BAdr2Edit.Text );
end;

procedure TBusSettingsDlg.ReadIni( section: string );
var i: Integer;
begin
    for i:=0 to ComponentCount-1 do
     if (Components[i].Tag>0) and (Components[i] is TComboBox) then
        TComboBox(Components[i]).ItemIndex := Ini.ReadInteger( section, IntToStr(Components[i].Tag), 0 );
    BAdr0Edit.Text:=Ini.ReadString( section, 'Default0', 'FF' );
    BAdr2Edit.Text:=Ini.ReadString( section, 'Default2', 'FF' );
end;

procedure TBusSettingsDlg.InitProfileCb;
var i,c: integer;
begin
   c:=Ini.ReadInteger( 'Profiles', 'Count', 0 );
   if c=0 then
   begin
     Ini.WriteInteger('Profiles', 'ActiveProfile', 0 );
     Ini.WriteInteger('Profiles', 'Count', 2 );
     Ini.WriteString( 'Profiles', 'Profile0', 'Philips Standard' );
     for i:=1 to 15 do
         Ini.WriteInteger( 'Profile0', IntToStr(i), Philips[i] );
     Ini.WriteString( 'Profiles', 'Profile1', 'Mir-Tronic' );
     for i:=1 to 15 do
         Ini.WriteInteger( 'Profile1', IntToStr(i), MirTronic[i] );
     c:=2;
   end;
   ProfileCb.Clear;
   for i:=0 to c-1 do
   begin
       ProfileCb.Items.Add( Ini.ReadString( 'Profiles', 'Profile'+IntToStr(i), '' ) );
   end;
   ProfileCb.ItemIndex:=Ini.ReadInteger( 'Profiles', 'ActiveProfile', 0 );
   {Load corresponding settings}
   ReadIni( 'Profile'+IntToStr(ProfileCb.ItemIndex) );
end;

function CbDuplicated( Cb: TComboBox; s: string ): Boolean;
var i: Integer;
begin
     Result:=False;
     for i:=0 to Cb.Items.Count-1 do
         if s=Cb.Items[i] then
            Result:=True;
end;

procedure TBusSettingsDlg.SaveAs;
var s: string;
begin
     if ProfNameDlg.ShowModal=mrOk then
     begin
      s:=ProfNameDlg.Edit1.Text;
      if CbDuplicated( ProfileCb, s ) then
      begin
        Application.MessageBox('Duplicate Profile. Profile not saved.','Error',MB_OK);
      end else begin
        ProfileCb.Items.Add( s );
        ProfileCb.ItemIndex := ProfileCb.Items.Count-1;
        Ini.WriteString(  'Profiles', 'Profile'+IntToStr(ProfileCb.ItemIndex), s );
        Ini.WriteInteger( 'Profiles', 'ActiveProfile', ProfileCb.ItemIndex );
        Ini.WriteInteger( 'Profiles', 'Count', ProfileCb.Items.Count );

        StoreIni( 'Profile'+IntToStr(ProfileCb.ItemIndex) );
      end;
     end;
end;

procedure TBusSettingsDlg.Delete;
var s: string; Start,i,k,v: Integer;
begin
     Start:=ProfileCb.ItemIndex;
     ProfileCb.Items.Delete( Start );
     Ini.WriteInteger( 'Profiles', 'Count', ProfileCb.Items.Count );
     {renumbering ini-File}
     for i:=Start to ProfileCb.Items.Count-1 do
     begin
        s:=Ini.ReadString(  'Profiles', 'Profile'+IntToStr(i+1), '' );
        Ini.WriteString(    'Profiles', 'Profile'+IntToStr(i  ), s );
        for k:=1 to 15 do
        begin
           v:=Ini.ReadInteger( 'Profile'+IntToStr(i+1), IntToStr(k), 0 );
           Ini.WriteInteger(   'Profile'+IntToStr(i  ), IntToStr(k), v );
        end;
        s:=Ini.ReadString( 'Profile'+IntToStr(i+1), 'Default0', 'FF' );
        Ini.WriteString(   'Profile'+IntToStr(i  ),'Default0', s );
        s:=Ini.ReadString( 'Profile'+IntToStr(i+1), 'Default2', 'FF' );
        Ini.WriteString(   'Profile'+IntToStr(i  ),'Default2', s );
     end;
     Ini.EraseSection( 'Profile'+IntToStr(ProfileCb.Items.Count) );
     if Start<ProfileCb.Items.Count then
        ProfileCb.ItemIndex:=Start
     else
        ProfileCb.ItemIndex:=ProfileCb.Items.Count-1;
     Ini.WriteInteger( 'Profiles', 'ActiveProfile', ProfileCb.ItemIndex );
     ReadIni( 'Profile'+IntToStr(ProfileCb.ItemIndex) );
end;

procedure TBusSettingsDlg.Save;
begin
     StoreIni( 'Profile'+IntToStr(ProfileCb.ItemIndex) );
     Ini.WriteInteger('Profiles', 'ActiveProfile', ProfileCb.ItemIndex );
end;

procedure TBusSettingsDlg.SaveAsBtnClick(Sender: TObject);
begin
     SaveAs;
end;

procedure TBusSettingsDlg.SaveBtnClick(Sender: TObject);
begin
     Save;
end;

procedure TBusSettingsDlg.DeleteBtnClick(Sender: TObject);
begin
   if Application.Messagebox('Really?','Delete Profile',MB_YESNO)=IDYES then
     Delete;
end;


procedure TBusSettingsDlg.ProfileCbChange(Sender: TObject);
begin
   ReadIni( 'Profile'+IntToStr(ProfileCb.ItemIndex) );
end;

end.
